![Banner](assets/banner.png?raw=true "Banner")
Stargate is an all-in-one DAW and plugin suite, designed to be a comprehensive
solution for music production, with a focus on providing unique and innovative
features, especially for EDM production.  To understand what Stargate is,
and why, read the
[project design principles](docs/project_design_principles.md).

# Links
- [Download Stargate demo projects](
    https://github.com/stargatedaw/stargate-v1-demo-projects)
- [Download instruments for Sampler1](https://github.com/sfzinstruments)
- [Download or contribute to our public domain sample pack](
    https://github.com/stargatedaw/stargate-sample-pack)
- Source code is mirrored on [Gitlab](https://gitlab.com/stargatedaw) and
  [Codeberg](https://codeberg.org/stargatedaw), however, releases, issues and
  pull requests are only on [Github](https://github.com/stargatedaw)

# Features
- A digital audio workstation (DAW) with a powerful pattern-based workflow
- A comprehensive suite of built-in instrument and effect plugins
- A basic wave editor
- Powerful track routing matrix with easy sidechaining
- Modular mixer architecture.  Mixer channels are a type of plugin that can
  be chosen per track send, mix and match plugins, or skip them when not needed
- Runs on Windows, Mac and Linux, x86 and ARM.  Can be ported to other
  platforms if there is sufficient demand
- Everything you need to create music in a single package, no need to install
  additional software
- Revolutionary CPU efficiency for DAW and plugins, minimum recommended
  hardware: Raspberry Pi 4, or a 15 year old laptop with a
  dual core CPU, 1GB of RAM and a 720p display.
- Support for display resolution from 720p to 4k and above.
- Optional portable flash drive install on Windows and
  [MacOS](docs/troubleshooting/macos_install.md)
- Broad audio and MIDI hardware support using Portaudio and Portmidi

# Screenshots
![Sequencer](assets/sequencer.png?raw=true "Sequencer")

![Audio Item](assets/audio_item.png?raw=true "Audio Item")

![Note Item](assets/note_item.png?raw=true "Note Item")

![Effect Plugins](assets/plugins.png?raw=true "Effect Plugins")

![Instrument Plugins](assets/va1.png?raw=true "Instrument Plugins")

![Routing](assets/routing.png?raw=true "Routing")

# Licensing

Stargate is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, under version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

For details on the GNU General Public License, see [the license](LICENSE).

